package com.yunzhi.nanyang.mapper;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.yunzhi.nanyang.entity.TaOrder;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

/**
 * <p>
 * 订单表 Mapper 接口
 * </p>
 *
 * @author yansen
 * @since 2022-03-08
 */
@Mapper
public interface TaOrderMapper extends BaseMapper<TaOrder> {

    @Select("SELECT fn_nextval(#{name})")
    int getNextOrderNO(@Param("name") String name);

    IPage<TaOrder> getAdminPage(IPage<TaOrder> pg,
                                @Param("userId") String userId,
                                @Param("orgId") String orgId,
                                @Param("orderNo") String orderNo,
                                @Param("machineryId") String machineryId,
                                @Param("typeId") String typeId,
                                @Param("personName") String personName,
                                @Param("phone") String phone,
                                @Param("payStatus") Integer payStatus,
                                @Param("dispatchStatus") Integer dispatchStatus,
                                @Param("workStatus") Integer workStatus,
                                @Param("isEvaluated") Integer isEvaluated,
                                @Param("isWarn") Boolean isWarn);

    IPage<TaOrder> getClientPage(IPage<TaOrder> pg,
                                 @Param("personId") String personId,
                                 @Param("q") String q);

    IPage<TaOrder> getOrderDispatched(IPage<TaOrder> pg,
                                      @Param("userId") String userId,
                                      @Param("workStatus") Integer workStatus,
                                      @Param("q") String q);

    List<TaOrder> checkMachineryDuty(@Param("machineryId") String machineryId,@Param("appointmentDate") String appointmentDate);

    int updatePayStatus(@Param("orderId") String orderId, @Param("payStatus") int payStatus);
}
